%global forgeurl0 https://gitlab.com/mission-center-devs/mission-center
Version: 1.0.0
%global tag0 v%{version}

%global forgeurl1 https://gitlab.com/mission-center-devs/gng
%global commit1 dcc600e18cfa17d56d0f12a61be2702cc7a015ae

%global forgeurl2 https://github.com/Syllo/nvtop
%global tag2 3.2.0

%forgemeta -a

Name:           mission-center
Release:        %autorelease
Summary:        Monitor your CPU, Memory, Disk, Network and GPU usage

License:        GPL-3.0-only
URL:            %{forgeurl0}
Source0:         %{forgesource0}
Source1:         %{forgesource1}
Source2:         %{forgesource2}
Patch0:             deps.diff
Patch1:             deps2.diff
Patch2: https://gitlab.com/mission-center-devs/mission-center/-/merge_requests/319.diff
Provides: bundled(mission-center-magpie)
Provides: bundled(nvtop) = %{tag2}
#mission centere uses a patched version of nvtop

BuildRequires: meson >= 0.63
BuildRequires: cargo
BuildRequires: cmake
BuildRequires: gcc
BuildRequires:  gcc-c++
BuildRequires: pkgconfig(protobuf)
BuildRequires: pkgconfig(python3)
BuildRequires: pkgconfig(libdrm)
BuildRequires: pkgconfig(gbm)
BuildRequires: pkgconfig(libudev)
BuildRequires: pkgconfig(gtk4)
BuildRequires: pkgconfig(egl)
BuildRequires: libadwaita-devel
BuildRequires: desktop-file-utils
BuildRequires: blueprint-compiler
BuildRequires: cargo-rpm-macros >= 24
BuildRequires: gettext
BuildRequires: desktop-file-utils
BuildRequires: appstream-data
BuildRequires: libappstream-glib

%description
Monitor your CPU, Memory, Disk, Network and GPU usage


%prep
%forgesetup -z 0
mkdir -p ./subprojects/magpie
tar -x --strip-components=1  -f %{SOURCE1} -C ./subprojects/magpie
mkdir -p ./subprojects/magpie/platform-linux/package/native
tar -x   -f %{SOURCE2} -C ./subprojects/magpie/platform-linux/package/native
patch -p1 < %{PATCH0}
patch -p1 < %{PATCH2}
pushd ./subprojects/magpie/
patch -p1 < %{PATCH1}
rm ./Cargo.lock
%cargo_prep
pushd ./platform-linux/package/native/nvtop-%{tag2}
%global nvtop $(pwd)
for i in ../../../3rdparty/nvtop/patches/* ; do patch -p1 < $i ; done
popd
popd
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires
pushd ./subprojects/magpie/ > /dev/null
%cargo_generate_buildrequires -t
popd > /dev/null

%build
%meson
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies
mkdir -p %{buildroot}/../mission-center-v%{version}/redhat-linux-build/subprojects/magpie/src/debug/build/native
cp -R ~/build/BUILD/mission-center-%{version}-build/mission-center-v%{version}/subprojects/magpie/platform-linux/package/native/nvtop-%{tag2} %{buildroot}/../mission-center-v%{version}/redhat-linux-build/subprojects/magpie/src/debug/build/native
%meson_build


%install
%meson_install
%find_lang missioncenter

%check
desktop-file-validate %{buildroot}/%{_datadir}/applications/io.missioncenter.MissionCenter.desktop
appstream-util validate-relax  %{buildroot}/%{_datadir}/metainfo/io.missioncenter.MissionCenter.metainfo.xml
%meson_test


%files -f missioncenter.lang
%doc README.md
%license COPYING
%{_datadir}/missioncenter/
%{_datadir}/applications/io.missioncenter.MissionCenter.desktop
%{_datadir}/metainfo/io.missioncenter.MissionCenter.metainfo.xml
%{_datadir}/glib-2.0/schemas/io.missioncenter.MissionCenter.gschema.xml
%{_datadir}/icons/hicolor/scalable/apps/io.missioncenter.MissionCenter.svg
%{_datadir}/icons/hicolor/symbolic/apps/io.missioncenter.MissionCenter-symbolic.svg
%{_bindir}/missioncenter-magpie
%{_bindir}/missioncenter


%changelog
%autochangelog
